# ------------------------------------------------------------------------------
# Validator functions
# ------------------------------------------------------------------------------

class ValidatorRegex:
    """
    Class that holds all predefined regex definitions for types.
    """
    # Linux paths
    file = "[a-zA-Z0-9._\-]+"
    path = "[a-zA-Z0-9._\-/]+"
    # RFC 1035 and RFC 5891
    hostname = r"(?!-)[A-Za-z0-9-]{1,63}(?<!-)"
    # RFC 1035 and RFC 5891
    domain = r"(?:\.(?!-)[A-Za-z0-9-]{1,63}(?<!-))*(?:\.(?!-)[A-Za-z0-9-]{2,24}(?<!-))+"
    # RFC 5322
    email_prefix = r"[a-zA-Z0-9]+(?:[._+-]?[a-zA-Z0-9]+)*"
    # RFC 3986
    url_proto = r"(https?:\/\/)?"
    url_port = r"(:[0-9]{2,5})?"
    url_path = r"(/(?:[A-Za-z0-9\-._~:@&=+$,;]+|(%[0-9A-Fa-f]{2}))*)*"
    url_query = r"(\?(?:[A-Za-z0-9\-._~:@&=+$,;]+|(%[0-9A-Fa-f]{2}))*)*"
    url_fragment = r"(#(?:[A-Za-z0-9\-._~:@&=+$,;]+|(%[0-9A-Fa-f]{2}))*)*"
    # RFC 791
    url_ipv4 = r"((25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])\.){3}(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])"
    # RFC 4291
    url_ipv6 = r"((([0-9A-Fa-f]{1,4}):){7}([0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}):){1,7}:|:((:[0-9A-Fa-f]{1,4}){1,7})|(([0-9A-Fa-f]{1,4}):){1,6}:([0-9A-Fa-f]{1,4})|(([0-9A-Fa-f]{1,4}):){1,5}(:([0-9A-Fa-f]{1,4})){1,2}|(([0-9A-Fa-f]{1,4}):){1,4}(:([0-9A-Fa-f]{1,4})){1,3}|(([0-9A-Fa-f]{1,4}):){1,3}(:([0-9A-Fa-f]{1,4})){1,4}|(([0-9A-Fa-f]{1,4}):){1,2}(:([0-9A-Fa-f]{1,4})){1,5}|([0-9A-Fa-f]{1,4}):((:[0-9A-Fa-f]{1,4}){1,6})|::((:[0-9A-Fa-f]{1,4}){1,7}|:)|((:[0-9A-Fa-f]{1,4}){1,7}:))"
